# -*- coding: utf-8 -*-

from Handlers import BaseHandler
from Utils import config
#-------------------------------------------------------------------------------
#
#-------------------------------------------------------------------------------
class ModemEmulation(BaseHandler.BaseHandler):
	#=======================================================
	# 
	#=======================================================
	def __init__(self):
		self._config = "/etc/mae3xx/mae370_asterisk.conf"
		self._defalut = "/etc/default/mae370"
		self._name = 'ModemEmulation'
		self._section = 'TCPSER'
		self._keys = ['port','device','speed','phone','modeminit']

	#=======================================================
	# 
	#=======================================================
	def Get(self, request):

		status = 200
		return self.readConfig(), status

	#=======================================================
	# 
	#=======================================================
	def Put(self, request):
		
		status = 200
		args = request.json
		self.writeConfig(args)
		if args['use'] == 'yes':
			self.service("modem_emulation", 'restart')
		else:
			self.service("modem_emulation", 'stop')
		return status
		
	#=======================================================
	# 	
	#=======================================================
	def readConfig(self):
		
		conf = {}
		cp = config.Config(self._config)
		for key in self._keys:
			if key == 'phone':
				list = []
				for i in range(10):
					value = cp.get('%s_%s' %(self._section,key+str(i)))
					if value:
						list.append(value)
					else:
						break
				conf[key] = list
			else:
				conf[key] = cp.get('%s_%s' %(self._section,key ))

		defalut = config.ConfigOption(self._defalut)
		use = defalut.get('START_TCPSER')
		if use:
			conf['use'] = use
		else:
			conf['use'] = 'no'

		return conf

	#=======================================================
	# 
	#=======================================================
	def writeConfig(self, args):

		cp = config.Config(self._config)
		defalut = config.ConfigOption(self._defalut)
		for key in args:
			if key == 'phone':
				for i in range(10):
					if len(args[key])-1 < i:
						cp.set('%s_%s' %(self._section, key+str(i)), '')
					else:
						cp.set('%s_%s' %(self._section, key+str(i)), args[key][i])
			elif key == 'use':
				defalut.set('START_TCPSER', args[key])
			else:
				cp.set('%s_%s' %(self._section, key), args[key])
		cp.dump()

