# -*- coding: utf-8 -*-

from Handlers import BaseHandler
from Utils import config
#-------------------------------------------------------------------------------
#
#-------------------------------------------------------------------------------
class SIP(BaseHandler.BaseHandler):
	#=======================================================
	# 
	#=======================================================
	def __init__(self):
		self._config = "/etc/mae3xx/mae370_asterisk.conf"
		self._name = 'SIP'
		self._cp = config.Config(self._config)
		self._keys = ['register','username','fromuser','secret','host', 'port', 'fromdomain','extension','dtmfmode']

	#=======================================================
	# 
	#=======================================================
	def Get(self, request):

		status = 200
		self._cp = config.Config(self._config)
		return self.readConfig(), status

	#=======================================================
	# 
	#=======================================================
	def Put(self, request):
		
		status = 200
		args = request.json
		self.writeConfig(args)
		self.call('gen_socketrelayconf -t sip', shell= True)

		return status
		
	#=======================================================
	# 	
	#=======================================================
	def readConfig(self):
		
		conf = {}
		
		for key in self._keys:
			conf[key] = self._cp.get('%s_%s' %(self._name,key ))
		return conf

	#=======================================================
	# 
	#=======================================================
	def writeConfig(self, args):

		for key in args:
			self._cp.set('%s_%s' %(self._name, key), args[key])
		self._cp.dump()

