# -*- coding: utf-8 -*-

from Handlers import BaseHandler
from Utils import config
#-------------------------------------------------------------------------------
#
#-------------------------------------------------------------------------------
class Socketrelay(BaseHandler.BaseHandler):
	#=======================================================
	# 
	#=======================================================
	def __init__(self):
		self._config = "/etc/mae3xx/mae370_asterisk.conf"
		self._name = 'Socketrelay'
		self._cp = config.Config(self._config)
		self._keys = ['use','sequence','username','ctrl_port','data_port','termios_cs', 'allow_list', 'remote', 'allow']

	#=======================================================
	# 
	#=======================================================
	def Get(self, request):

		status = 200
		self._cp = config.Config(self._config)
		return self.readConfig(), status

	#=======================================================
	# 
	#=======================================================
	def Put(self, request):
		
		status = 200
		args = request.json
		self.writeConfig(args)
		self.call('gen_socketrelayconf -t relay', shell= True)
		if args['use'] == 'yes':
			self.service('socket-relay', 'restart')
			self.update_rc('socket-relay', 'enable')
		else:
			self.service('socket-relay', 'stop')
			self.update_rc('socket-relay', 'disable')
		return status
		
	#=======================================================
	# 	
	#=======================================================
	def readConfig(self):
		
		conf = {}
		
		for key in self._keys:
			if key in ('remote', 'allow'):
				list = []
				for i in range(10):
					value = self._cp.get('%s_%s' %(self._name.upper(),key+str(i)))
					if value:
						list.append(value)
					else:
						break
				conf[key] = list
			else:
				conf[key] = self._cp.get('%s_%s' %(self._name.upper(),key ))
		return conf

	#=======================================================
	# 
	#=======================================================
	def writeConfig(self, args):

		for key in args:
			if key in ('remote', 'allow'):
				for i in range(10):
					if len(args[key])-1 < i:
						self._cp.set('%s_%s' %(self._name.upper(), key+str(i)), '')
					else:
						self._cp.set('%s_%s' %(self._name.upper(), key+str(i)), args[key][i])
			else:
				self._cp.set('%s_%s' %(self._name.upper(), key), args[key])

		self._cp.dump()

