#!/bin/bash

. /etc/socket-relay/path.conf

TAG=agi_release
OUTPUT=/tmp/agi_release.out

cp /dev/null $OUTPUT

while read line; do
    if [ -n $line ]; then
        break;
    fi

    echo $line >> $OUTPUT
    
    AGI=$(echo -n $line | awk -F":" '{print $1}')
    VAL=$(echo -n $line | awk -F":" '{print $2}' | sed -e 's/^ *//')

    if [ "$AGI" = "agi_type" ]; then
        TYPE=$VAL
    fi
done

if [ "$TYPE" = "DAHDI" -a -f $PID_OUTCALLING_DATA_FILE ]; then
    if [ "$SYNC_CONNECT" = "yes" ]; then
        $OUTCALLING_PATH/outcalling.sh stop > /dev/null 2>&1
    else
        $OUTCALLING_PATH/outcalling.sh stop > /dev/null 2>&1 &
    fi
fi

if [ "$TYPE" = "DAHDI" -a -f $PID_INCOMING_DATA_FILE ]; then
    if [ "$SYNC_CONNECT" = "yes" ]; then
        $INCOMING_PATH/modem_disconnect.sh > /dev/null 2>&1
    else
        $INCOMING_PATH/modem_disconnect.sh > /dev/null 2>&1 &
    fi
fi

echo "SUCCESS"

exit 0
