#!/bin/bash

TAG=modem_setup

TTYDEV=$1
CHAT_CONFIG_FILE=$2
STTY_CONFIG_FILE=$3
DEBUG=$4

usage()
{
    echo "Usage: $0 [device] [chat file] [stty file] <debug>" >&2
    exit 1
}

if [ "$TTYDEV" = "" ]; then
    usage
fi

if [ "$CHAT_CONFIG_FILE" = "" ]; then
    usage
else
    if [ ! -f $CHAT_CONFIG_FILE ]; then
        logger -t $TAG "${CHAT_CONFIG_FILE}: No such file or directory"
        exit 1
    fi
fi

if [ "$STTY_CONFIG_FILE" = "" ]; then
    usage
else
    if [ ! -f $STTY_CONFIG_FILE ]; then
        logger -t $TAG "${STTY_CONFIG_FILE}: No such file or directory"
        exit 1
    fi
fi

if [ "$DEBUG" = "debug" ]; then
    DEBUG="-vs"
else
    DEBUG="-v"
fi

#chmod 660 /dev/$TTYDEV #TODO

STTY_CONFIG=$(cat $STTY_CONFIG_FILE)
stty -F /dev/$TTYDEV $STTY_CONFIG

chat $DEBUG -f $CHAT_CONFIG_FILE < /dev/$TTYDEV > /dev/$TTYDEV

exit $?
